package com.cnd3b.common.websocket;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.BaseClass;
import com.cnd3b.common.D3BReturnObject_Err;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.parameter.parameter;

import javax.websocket.*;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;
import java.io.IOException;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Calendar;
import java.util.Date;
import java.util.concurrent.ConcurrentHashMap;

//ws://127.0.0.1:8080/samex/webSocket/829fef9884bbf7f9fb9c51499d7b332f
@ServerEndpoint("/webSocket/{accesstoken}")
public class WebClientSocket extends BaseClass {

    private Session session;
    //ǰӶ˺ID
    private long userid;
    private Row userRow;
    private String accesstoken;
    private Date createdate;

    /**
     * ӿ
     *
     * @param accesstoken
     * @param session
     * @throws IOException
     */
    @OnOpen
    private void onOpen(@PathParam("accesstoken") String accesstoken, Session session) throws IOException {
        this.session = session;
        this.accesstoken = accesstoken;
        createdate = getDateTime();
        if (parameter.tokenlist.containsKey(accesstoken)) {
            userid = parameter.tokenlist.get(accesstoken);
            userRow = parameter.userIdList.get(userid);
        } else {
            JSONObject methodobject = new JSONObject();
            methodobject.put("type", "err");
            methodobject.put("msg", "½");
            sendSystemMessage(methodobject);
            return;
        }
        if (parameter.websocketClients.containsKey(userid)) {
            parameter.websocketClients.get(userid).put(accesstoken, this);
        } else {
            ConcurrentHashMap<String, WebClientSocket> map = new ConcurrentHashMap<>();
            map.put(accesstoken, this);
            parameter.websocketClients.put(userid, map);
        }
        parameter.loginDate.put(userid, createdate);
        System.err.println("OpenSession:" + userid);
    }

    /**
     * ӹر
     *
     * @throws IOException
     */
    @OnClose
    private void onClose() throws IOException {
        if (parameter.websocketClients.containsKey(userid)) {
            parameter.websocketClients.get(userid).remove(accesstoken);
            if (parameter.websocketClients.get(userid).isEmpty()) {
                parameter.websocketClients.remove(userid);
            }
            System.err.println("CloseSession:" + userid);
        }
    }

    /**
     * {
     * "dialogid":1,//Իid
     * "messagetype":"text",//Ϣ
     * "description":"",//ϢժҪ
     * "data":{
     * "message":""//,
     * }
     * },
     * {
     * "dialogid":1,
     * "messagetype":"file",//text,file,data,image,
     * "description":"",
     * "data":{
     * "ownertable":"",
     * "ownerid":"",
     * "serialnumber":"",
     * "postfix":"",
     * "fobsurl":"",
     * "fobsurl_minimage":"",
     * "fobsurl_hls":"",
     * "fdocument":""
     * }
     * },
     * {
     * "dialogid":1,
     * "messagetype":"data",//text,file,data,image
     * "description":"",
     * "data":{
     * "type":"",
     * "ownertable":"",
     * "ownerid":""
     * }
     * }
     *
     * @param messageObject
     * @throws IOException
     */
    /**
     * Ϣ
     *
     * @param RequestContent
     * @throws IOException
     */
    @OnMessage
    private void onMessage(String RequestContent) throws IOException {
        if (RequestContent == null || RequestContent.equals("")) {
            return;
        }
        if ("isalive".equalsIgnoreCase(RequestContent)) {
            session.getAsyncRemote().sendText("alive");
            return;
        }

        /**
         * ֤ǷΪ淶SONObjectʽ
         */
        JSONObject requestcontent = null;
        try {
            requestcontent = JSONObject.parseObject(RequestContent);
        } catch (Exception e) {
            return;
        }
        /**
         * ֤Ƿļֵ
         */
        String[] mustkeys = {"classname", "method", "content"};
        for (String mustkey : mustkeys) {
            if (!requestcontent.containsKey(mustkey)) {
                return;
            }
        }
        /**
         * ֤еcontentǷΪ淶SONObjectʽ
         */
        JSONObject content = new JSONObject();
        try {
            content = requestcontent.getJSONObject("content");
        } catch (Exception e) {
            return;
        }

        /**
         * ֤еtokenǷЧ
         */
        String className = requestcontent.getString("classname");

        parameter.requesttime.put(accesstoken, Calendar.getInstance().getTime());

        String methodName = requestcontent.getString("method");
        if (content.isEmpty()) {
            content = new JSONObject();
        }
        content.put("$classname", className);
        content.put("$method", methodName);
        content.put("$accesstoken", accesstoken);

        String key = className + "." + methodName;
        String result;
        Object obj = null;
        try {

            long starttimes = Calendar.getInstance().getTimeInMillis();
            /**
             * ִ󷽷
             */
            Class clz = Class.forName("com.cnd3b.websocketcontroller." + className);
            Constructor cla = clz.getDeclaredConstructor(JSONObject.class);
            obj = cla.newInstance(content);
            Method method = obj.getClass().getDeclaredMethod(methodName);
            result = (String) method.invoke(obj);
            long endtimes = Calendar.getInstance().getTimeInMillis();
            saveCallMethodMsg(key, true, endtimes - starttimes);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("Ҳָ" + className).toString();
        } catch (InstantiationException e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("" + className + "ʵ쳣").toString();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("" + className + "ȫȨ쳣ܸΪpublic").toString();
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("Ҳָ" + className + "" + methodName + "").toString();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("" + className + "" + methodName + "Ϸ").toString();
        } catch (InvocationTargetException e) {
            Throwable targetException = e.getTargetException();
            D3BReturnObject_Err d3BReturnObject_err = new D3BReturnObject_Err();
            d3BReturnObject_err.setErrMsg(targetException.getMessage());
            result = d3BReturnObject_err.toString();
        } catch (Exception e) {
            e.printStackTrace();
            result = new D3BReturnObject_Err().setErrMsg("δ֪쳣" + e.getMessage()).toString();
        } finally {
            if (obj != null) {
                try {
                    obj.getClass().getMethod("p2ServerSystemPaoSetClose").invoke(obj);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
        return;
    }

    /**
     * ¼
     *
     * @param key
     * @param fromdb
     * @param time
     */
    private void saveCallMethodMsg(String key, boolean fromdb, long time) {
        long callmethodTimes = parameter.callmethodTimes.containsKey(key) ? parameter.callmethodTimes.get(key) : 0L;

        //
        parameter.callmethodTimes.put(key, callmethodTimes + 1L);

        //ʱ
        parameter.lastcallmethodtime.put(key, Calendar.getInstance().getTime());

        //ӻȡĴ
        long callmethod_fromcacheTimes = parameter.callmethod_fromcacheTimes.containsKey(key) ? parameter.callmethod_fromcacheTimes.get(key) : 0L;
        if (!fromdb) {
            /**
             * ӻȡ
             */
            parameter.callmethod_fromcacheTimes.put(key, callmethod_fromcacheTimes + 1L);
        } else {
            /**
             * ѯºʱ
             */
            parameter.callmethodLastTimeLong.put(key, time);


            long totaltimes = callmethodTimes - callmethod_fromcacheTimes;

            /**
             * ѯƽʱ
             */
            long callmethodTimeLong = parameter.callmethodTimeLong.containsKey(key) ? parameter.callmethodTimeLong.get(key) : 0L;

            parameter.callmethodTimeLong.put(key, (callmethodTimeLong * totaltimes + time) / (totaltimes + 1));
        }
    }

    @OnError
    private void onError(Session session, Throwable error) {
        error.printStackTrace();
    }

    /**
     * ԵǰӷͶԻϢ
     *
     * @param message
     */
    public void sendDialogMessage(JSONObject message) {
        JSONObject object = new JSONObject();
        object.put("msgtype", "imdialog");
        object.put("message", message);
        session.getAsyncRemote().sendText(object.toJSONString());
    }

    /**
     * ԵǰӷϵͳϢ
     *
     * @param message
     */
    public void sendSystemMessage(JSONObject message) {
        JSONObject object = new JSONObject();
        object.put("msgtype", "system");
        object.put("message", message);
        session.getAsyncRemote().sendText(object.toJSONString());
    }

}