package com.cnd3b.restcontroller.enterprise.live;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import com.cnd3b.utility.polyv.Polyv;
import net.polyv.live.v1.entity.channel.operate.LiveChannelResponse;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.HashMap;
import java.util.Random;

public class live extends Controller {
    public live(JSONObject content) {
        super(content);
    }

    /**
     * ȡƵб
     *
     * @return
     */
    public String getLiveCategory() {
        Polyv polyv = new Polyv();
        HashMap<Integer, String> map = polyv.listCategory();
        JSONArray array = new JSONArray();
        for (int id : map.keySet()) {
            JSONObject object = new JSONObject();
            object.put("categoryId", id);
            object.put("categoryName", map.get(id));
            array.add(object);
        }
        return getSucReturnObject().setData(array).toString();
    }

    /**
     * ֱбѯ
     *
     * @return
     */
    public String queryChannelList() {
        /**
         *
         */
        String[] sortfield = {"case t1.livestatus when 'waiting' then 0 else '' end,t1.createdate desc"};
        String sort = getSort(sortfield, "case t1.livestatus when 'waiting' then 0 else '' end,t1.createdate desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.channelname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t2.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("categoryid") && !"".equals(whereObject.getString("categoryid"))) {
                where.append(" and(");
                where.append("t1.categoryid ='").append(whereObject.getString("categoryid")).append("' ");
                where.append(")");
            }
        }
        SQLFactory costhead = new SQLFactory(this, "ֱбѯ", pageSize, pageNumber, sort);
        costhead.addParameter("siteid", siteid);
        costhead.addParameter_SQL("where", where);
        String sql = costhead.getSQL();
        Rows rows = dbConnect.runSqlQuery(costhead.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ֱѯ
     *
     * @return
     */
    public String queryChannelMain() {
        long tliveid = content.getLong("tliveid");
        SQLFactory sqlFactory = new SQLFactory(this, "ֱѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tliveid", tliveid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ֱ
     *
     * @return
     */
    public String createLive() throws P2Exception {
        long tagentsid = content.getLong("tagentsid");
        String channelname = content.getString("channelname");
        int categoryid = content.getInteger("categoryid");
        long tactivityid = content.getLongValue("tactivityid");
        String channelPasswd = createPassWord();
        Polyv polyv = new Polyv();
        LiveChannelResponse liveChannelResponse = polyv.createChannel(channelname, channelPasswd, categoryid);
        if (liveChannelResponse != null) {
            PaoSetRemote tliveSet = getP2ServerSystemPaoSet("tlive");
            PaoRemote tlive = tliveSet.addAtEnd();
            tlive.setValue("siteid", siteid);
            tlive.setValue("tagentsid", tagentsid);
            tlive.setValue("categoryid", categoryid);//ID
            if (tactivityid > 0) {
                tlive.setValue("tactivityid", tactivityid);//ID
            }
            tlive.setValue("categoryname", polyv.listCategory().get(categoryid));//
            tlive.setValue("channelid", liveChannelResponse.getChannelId());//ƵID
            tlive.setValue("channelname", liveChannelResponse.getName());//Ƶ
            tlive.setValue("channelpasswd", channelPasswd);//
            tlive.setValue("livestatus", "unStart");//ֱ״̬
            tlive.setValue("fliveshowurl", "https://live.polyv.cn/watch/" + liveChannelResponse.getChannelId());//ۿַ
            tlive.setValue("fliveurl_web", "https://live.polyv.net/web-start/login?channelId=" + liveChannelResponse.getChannelId());//ҳַ
            tlive.setValue("fliveurl_client", "https://console.polyv.net/live/start-client.html?channelId=" + liveChannelResponse.getChannelId());//ͻ˿ַ
            tlive.setValue("fassistanturl", "https://console.polyv.net/live_v2/teacher.html");//̵ַ
            tlive.setValue("channelcoverimageurl", polyv.getChannelImage(liveChannelResponse.getChannelId(), "unStart"));//ͼַ
            tlive.setValue("createby", username);
            tlive.setValue("createdate", sysdate);
            if (content.containsKey("tliveapplyid")) {
                tlive.setValue("tliveapplyid", content.getLong("tliveapplyid"));
            }
            content.put("tliveid", tlive.getUniqueIDValue());
            tliveSet.save();

        } else {
            return getErrReturnObject().setErrMsg("ֱ䴴ʧܣ").toString();
        }
        return queryChannelMain();
    }

    /**
     * ޸ֱ
     *
     * @return
     */
    public String modifyLive() throws P2Exception {
        long tliveid = content.getLong("tliveid");
        String channelname = content.getString("channelname");
        int categoryid = content.getInteger("categoryid");
        PaoSetRemote tliveSet = getP2ServerSystemPaoSet("tlive", "siteid='" + siteid + "' and tliveid='" + tliveid + "'");
        if (tliveSet.isEmpty()) {
            return getErrReturnObject().setErrMsg("ҲǰֱϢ").toString();
        }
        PaoRemote tlive = tliveSet.getPao(0);
        Polyv polyv = new Polyv();
        boolean liveChannelResponse = polyv.updateChannelSetting(tlive.getString("channelid"), channelname, categoryid);
        if (liveChannelResponse) {
            tlive.setValue("categoryid", categoryid);//ID
            tlive.setValue("categoryname", polyv.listCategory().get(categoryid));//
            tlive.setValue("channelname", channelname);//Ƶ
            tliveSet.save();
        }
        return queryChannelMain();
    }


    /**
     * ֱⲿȨ
     *
     * @return
     */
    public String setChannelAuth() {
        long tliveid = content.getLong("tliveid");
        Rows rows = dbConnect.runSqlQuery("select channelid from tlive where siteid='" + siteid + "' and tliveid=" + tliveid);
        if (rows.isEmpty()) {
            return getErrReturnObject().setErrMsg("Ҳǰֱ").toString();
        }
        String channelid = rows.get(0).getString("channelid");
        Polyv polyv = new Polyv();
        String secretKey = polyv.updateChannelAuthExternal(channelid);
        if (secretKey == null) {
            return getErrReturnObject().setErrMsg("ֱⲿȨʧܣ").toString();
        } else {
            String fliveshowurl = "https://www.buwanjia.com/customer/index.html#/authLiveLogin?tliveid=" + tliveid;
            String status = dbConnect.runSqlUpdate("update tlive set fliveshowurl='" + fliveshowurl + "', fisneedauth=1,secretkey='" + secretKey + "' where siteid='" + siteid + "' and tliveid='" + tliveid + "'");
            if (status.equals("true")) {
                return queryChannelMain();
            } else {
                return getErrReturnObject().setErrMsg(status).toString();
            }
        }
    }

    /**
     * رֱⲿȨ
     *
     * @return
     */
    public String closeChannelAuth() {
        long tliveid = content.getLong("tliveid");
        Rows rows = dbConnect.runSqlQuery("select channelid from tlive where siteid='" + siteid + "' and tliveid=" + tliveid);
        if (rows.isEmpty()) {
            return getErrReturnObject().setErrMsg("Ҳǰֱ").toString();
        }
        String channelid = rows.get(0).getString("channelid");
        Polyv polyv = new Polyv();
        if (polyv.closeChannelAuthExternal(channelid)) {
            String fliveshowurl = "https://live.polyv.cn/watch/" + channelid;
            String status = dbConnect.runSqlUpdate("update tlive set fliveshowurl='" + fliveshowurl + "', fisneedauth=0,secretkey=null where siteid='" + siteid + "' and tliveid='" + tliveid + "'");
            if (status.equals("true")) {
                return queryChannelMain();
            } else {
                return getErrReturnObject().setErrMsg(status).toString();
            }
        } else {
            return getErrReturnObject().setErrMsg("رֱⲿȨʧ").toString();
        }
    }

    /**
     * ֱɾ
     *
     * @return
     */
    public String deleteLive() {
        String tliveid = content.getString("tliveid");

        Rows rows = dbConnect.runSqlQuery("select channelid from tlive where siteid='" + siteid + "' and tliveid=" + tliveid);
        if (rows.isEmpty()) {
            return getErrReturnObject().setErrMsg("Ҳǰֱ").toString();
        }
        String channelid = rows.get(0).getString("channelid");
        Polyv polyv = new Polyv();
        if (polyv.deleteChannel(channelid)) {
            SQLFactory sqlFactory = new SQLFactory(this, "ֱɾ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("tliveid", tliveid);
            sqlFactory.addParameter("channelid", channelid);
            String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
            if ("true".equalsIgnoreCase(status)) {
                return getSucReturnObject().toString();
            } else {
                return getErrReturnObject().setErrMsg(status).toString();
            }
        } else {
            return getErrReturnObject().setErrMsg("ֱɾʧ").toString();
        }
    }

    /**
     * ֱȨ
     *
     * @return
     */
    public String liveauthorization() {
        if (!content.containsKey("tliveid")) {
            return getErrReturnObject().setErrMsg("ֱЧ").toString();
        }
        String tliveid = content.getString("tliveid");//ֱID
        Rows rows = dbConnect.runSqlQuery("select channelId,secretkey from tlive where siteid='" + siteid + "' and tliveid='" + tliveid + "'");
        if (rows.isEmpty()) {
            return getErrReturnObject().setErrMsg("ֱЧ").toString();
        }
        return getSucReturnObject().setData(new Polyv().getSignUrl(rows.get(0).getString("channelId"), rows.get(0).getString("secretkey"), userid)).toString();
    }


    private String createPassWord() {
        String allChar = "1234567890";
        StringBuffer sb = new StringBuffer();
        Random random = new Random();
        for (int i = 0; i < 6; i++) {
            sb.append(allChar.charAt(random.nextInt(allChar.length())));
        }
        return sb.toString();
    }

    /**
     * ֱбѯ
     *
     * @return
     */
    public String getSYLiveApplyList() {
        SQLFactory sqlFactory = new SQLFactory(this, "ֱбѯ", pageSize, pageNumber, "(case when t1.fstatus=''then 0 else 1 end),t1.createdate desc");
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).preloading(1).toString();
    }

    /**
     * ˽룬Զֱ
     *
     * @return
     */
    public String auditSYLiveApply() throws P2Exception {
        String tliveapplyid = content.getString("tliveapplyid");
        String tagentsid = content.getString("tagentsid");
        String where = "tagentsid = " + tagentsid + " AND tliveapplyid = " + tliveapplyid;
        PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("tliveapply", where);
        if (paoSetRemote.isEmpty()) {
            return getErrReturnObject().setErrMsg("δҵӦ").toString();
        } else {
            String sql = "SELECT*FROM tlive WHERE categoryname='˽ֱ' AND tagentsid=" + tagentsid;
            Rows rows = dbConnect.runSqlQuery(sql);
            if (rows.totalRows > 0) {
                return getErrReturnObject().setErrMsg("Ѵ˽ֱ").toString();
            } else {
                //޸״̬
                PaoRemote paoRemote = paoSetRemote.getPao(0);
                paoRemote.setValue("fstatus", "");
                paoRemote.setValue("CHECKBY", username);
                paoRemote.setValue("CHECKDATE", getDateTime_Str());
                paoSetRemote.save();
                //ֱ
                content.put("tliveapplyid", tliveapplyid);
                content.put("tagentsid", tagentsid);
                content.put("channelname", "˽ֱ");
                content.put("categoryid", getCategoryId("˽ֱ"));
                return createLive();
            }
        }
    }


    /**
     * ͨƵƻȡӦķid
     *
     * @param categoryName
     * @return
     */
    public int getCategoryId(String categoryName) {
        Polyv polyv = new Polyv();
        HashMap<Integer, String> map = polyv.listCategory();
        int categoryId = -1;
        for (int id : map.keySet()) {
            if (map.get(id).equals(categoryName)) {
                categoryId = id;
            }
        }
        return categoryId;
    }

}
