package com.cnd3b.restcontroller.system.im.imdialog;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.parameter.parameter;
import com.cnd3b.common.websocket.WebClientSocket;
import com.cnd3b.utility.Encryption;
import org.apache.ibatis.jdbc.SQL;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;
import java.util.Calendar;

public class imdialog extends Controller {

    /**
     * 캯
     *
     * @param content
     */
    public imdialog(JSONObject content) {
        super(content);
    }

    /**
     * ȺԻбѯ
     *
     * @return
     */
    public String query_imdialogList() {
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fimdialogname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("fimdialogtype") && !"".equals(whereObject.getString("fimdialogtype"))) {
                where.append(" and(");
                where.append("t1.fimdialogtype ='").append(whereObject.getString("fimdialogtype")).append("' ");
                where.append(")");
            }
            //fimdialogtype2͵
            if (whereObject.containsKey("fimdialogtype2") && !"".equals(whereObject.getString("fimdialogtype2"))) {
                where.append(" and(");
                where.append("t1.fimdialogtype !='").append(whereObject.getString("fimdialogtype2")).append("' ");
                where.append(")");
            }
        }
        SQLFactory timdialogSQL = new SQLFactory(this, "ʱͨѶͨȺбѯ");
        timdialogSQL.addParameter("siteid", siteid);
        timdialogSQL.addParameter("tenterprise_userid", userid);
        timdialogSQL.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(timdialogSQL.getSQL());

        SQLFactory timdialoguserSQL = new SQLFactory(this, "ʱͨѶȺԱбѯ");
        timdialoguserSQL.addParameter("siteid", siteid);
        timdialoguserSQL.addParameter_in("timdialogid", rows.toArrayList("timdialogid"));
        RowsMap timdialoguserRowsMap = dbConnect.runSqlQuery(timdialoguserSQL.getSQL()).toRowsMap("timdialogid");

        SQLFactory timnewmsgSQL = new SQLFactory(this, "ʱͨѶͨȺϢѯ");
        timnewmsgSQL.addParameter("siteid", siteid);
        timnewmsgSQL.addParameter_in("timdialogid", rows.toArrayList("timdialogid"));
        RowsMap newmsgmap = timnewmsgSQL.runSqlQuery().toRowsMap("timdialogid");
        for (Row row : rows) {
            Rows newmsgrows = newmsgmap.get(row.getString("timdialogid"));
            for (Row newmsg : newmsgrows) {
                newmsg.put("message", JSONObject.parseObject(newmsg.getString("message")));
                newmsg.put("fisonline", parameter.websocketClients.containsKey(newmsg.getLong("tenterprise_userid")) ? 1 : 0);
            }
            row.put("latestnews", newmsgrows);//Ϣ

            Rows timdialoguserRows = timdialoguserRowsMap.get(row.getString("timdialogid"));
            for (Row user : timdialoguserRows) {
                user.put("headportraiturl", getHeadPic(user.getLong("tenterprise_userid")));
            }
            row.put("users", timdialoguserRows);//ȺԱͷ
        }
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

    /**
     * Ⱥѯ
     *
     * @return
     */
    public String query_imdialogMain() throws D3bException, P2Exception {
        long timdialogid = content.getLong("timdialogid");
        SQLFactory timdialogSQL = new SQLFactory(this, "ʱͨѶȺѯ");
        timdialogSQL.addParameter("siteid", siteid);
        timdialogSQL.addParameter("tenterprise_userid", userid);
        timdialogSQL.addParameter("timdialogid", timdialogid);

        Rows rows = dbConnect.runSqlQuery(timdialogSQL.getSQL());
        for (Row row : rows) {
            SQLFactory timdialoguserSQL = new SQLFactory(this, "ʱͨѶȺԱбѯ");
            timdialoguserSQL.addParameter("siteid", siteid);
            timdialoguserSQL.addParameter_in("timdialogid", content.getString("timdialogid"));
            Rows userrows = dbConnect.runSqlQuery(timdialoguserSQL.getSQL());

            int onlinecount = 0;
            for (Row user : userrows) {
                boolean isonline = parameter.websocketClients.containsKey(user.getLong("tenterprise_userid"));
                if (isonline) {
                    user.put("fisonline", 1);
                    onlinecount = onlinecount + 1;
                } else {
                    user.put("fisonline", 0);
                }
                user.put("headportraiturl", getHeadPic(user.getLong("tenterprise_userid")));
            }
            row.put("users", userrows);
            row.put("usertotalcount", userrows.size());
            row.put("useronlinecount", onlinecount);
        }
        if (content.containsKey("message")) {
            //ʼ¼
            JSONObject messageObject = content.getJSONObject("message");
            long messageuserid = messageObject.getJSONObject("sendfrom").getLong("userid");
            messageObject.put("timdialogid", timdialogid);
            messageObject.put("fdatetime", getDateTime_Str());
            messageObject.put("fmessageid", new Encryption().Encode_MD5(siteid + messageuserid + Calendar.getInstance().getTimeInMillis()));

            SQLFactory sqlFactory = new SQLFactory(this, "ʱͨѶȺϢ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("fnotes", "ظ");
            sqlFactory.addParameter("timdialogid", timdialogid);
            sqlFactory.addParameter("tenterprise_userid", messageuserid);
            sqlFactory.addParameter("fmessageobj", messageObject.toJSONString());
            sqlFactory.addParameter("fmessageid", messageObject.getString("messageid"));
            sqlFactory.addParameter("fmessagetype", messageObject.getString("ftype"));

            if ("data".equals(messageObject.getString("ftype"))) {
                sqlFactory.addParameter("ownerid", messageObject.getJSONObject("data").getString("ownerid"));
                sqlFactory.addParameter("ownertable", messageObject.getJSONObject("data").getString("ownertable"));
            } else {
                sqlFactory.addParameter("ownerid", "null");
                sqlFactory.addParameter("ownertable", "null");
            }
            dbConnect.runSqlUpdate(sqlFactory.getSQL());
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * һϵ
     *
     * @return
     */
    public String quickcontact() throws D3bException, P2Exception {
        long tenterprise_userid = content.getLongValue("tenterprise_userid");//ݶԷuseridһһԻ
        SQLFactory factory = new SQLFactory(this, "ûIDѯһһԻID");
        factory.addParameter("siteid", siteid);
        factory.addParameter_in("tenterprise_userid", new String[]{String.valueOf(userid), String.valueOf(tenterprise_userid)});
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        if (!rows.isEmpty()) {
            content.put("timdialogid", rows.get(0).getLong("timdialogid"));
            return query_imdialogMain();
        } else {
            JSONArray usersArray = new JSONArray();
            usersArray.add(String.valueOf(userid));
            usersArray.add(String.valueOf(tenterprise_userid));
            content.put("fimdialogname", username + "-" + getUser(tenterprise_userid).getString("fname"));
            content.put("fimdialogtype", "ͨ");
            content.put("users", usersArray);
            return insertOrModify();
        }
    }


    /**
     * ȺϢѯ
     *
     * @return
     */
    public String query_imdialogMessage() {
        long timdialogid = content.getLong("timdialogid");
        /**
         *
         */
        String[] sortfield = {"t1.timdialogmessageid desc"};
        String sort = getSort(sortfield, "t1.timdialogmessageid desc");

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fnotes like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("begdate") && !"".equals(whereObject.getString("begdate"))) {
                where.append(" and convert(varchar(10),t1.createdate,120)>=").append("'").append(whereObject.getString("begdate")).append("'");
            }
            if (whereObject.containsKey("enddate") && !"".equals(whereObject.getString("enddate"))) {
                where.append(" and convert(varchar(10),t1.createdate,120)<=").append("'").append(whereObject.getString("enddate")).append("'");
            }
        }

        SQLFactory timdialogSQL = new SQLFactory(this, "ʱͨѶȺʷϢѯ", pageSize, pageNumber, sort);
        timdialogSQL.addParameter("siteid", siteid);
        timdialogSQL.addParameter("timdialogid", timdialogid);
        timdialogSQL.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(timdialogSQL.getSQL());
        for (Row row : rows) {
            String message = row.getString("message");
            row.put("message", JSONObject.parseObject(message));
        }
        //δϢ
        dbConnect.runSqlUpdate("update timdialogusers set funreadmsgcount=0 where siteid='" + siteid + "' and timdialogid='" + timdialogid + "' and tenterprise_userid='" + userid + "'");
        return getSucReturnObject().setDataByPaging(rows).toString();
    }

    public String restUnReadMsgCount() {
        long timdialogid = content.getLong("timdialogid");
        dbConnect.runSqlUpdate("update timdialogusers set funreadmsgcount=0 where siteid='" + siteid + "' and timdialogid='" + timdialogid + "' and tenterprise_userid='" + userid + "'");
        return getSucReturnObject().toString();
    }


    /**
     * ½Ի
     *
     * @return
     * @throws D3bException
     * @throws P2Exception
     */
    public String insertOrModify() throws D3bException, P2Exception {
        long timdialogid = content.getLongValue("timdialogid"); //ȺID ʱĬϴ0
        String fimdialogname = content.getString("fimdialogname", "timdialog.fimdialogname", "Ⱥ");//Ⱥ
        String fimdialogtype = content.getString("fimdialogtype");//Ի
        String ownertable = content.getString("ownertable");//б
        String ownerid = content.getString("ownerid");//бID

        ArrayList<String> sqlList = new ArrayList<>();

        PaoSetRemote timdialogSet = getP2ServerSystemPaoSet("timdialog", "siteid='" + siteid + "' and timdialogid='" + timdialogid + "'");
        PaoRemote timdialog = null;
        if (timdialogid <= 0 || timdialogSet.isEmpty()) {
            /**
             * Ի
             */
            timdialog = timdialogSet.addAtEnd();
            timdialog.setValue("siteid", siteid, 11L);//ҵID
            timdialog.setValue("createby", username, 11L);//
            timdialog.setValue("createdate", sysdate, 11L);//ʱ
            timdialog.setValue("fimdialogtype", fimdialogtype, 11L);//Ի
            timdialog.setValue("ownertable", ownertable, 11L);//б
            timdialog.setValue("ownerid", ownerid, 11L);//бID
            timdialog.setValue("tenterprise_userid", userid, 11L);//˺ID
            timdialogid = timdialog.getUniqueIDValue();
        } else {
            timdialog = timdialogSet.getPao(0);
        }
        timdialog.setValue("fimdialogname", fimdialogname, 11L);//Ի
        timdialogSet.save();
        /**
         * ڳʼԻԱ
         */
        JSONArray usersArray = content.getJSONArray("users");
        ArrayList<String> userlist = new ArrayList<>();
        usersArray.add(userid);//ĬϽԱȺ
        for (Object user : usersArray) {
            userlist.add(String.valueOf(user));
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ʱͨѶȺԱ");
        sqlFactory.addParameter("createby", username);
        sqlFactory.addParameter("timdialogid", timdialogid);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tenterprise_userid", userlist);
        sqlList.add(sqlFactory.getSQL());
        dbConnect.runSqlUpdate(sqlList);
        content.put("timdialogid", timdialogid);
        return query_imdialogMain();
    }

    /**
     * ȺԱϢ
     *
     * @return
     */
    public String updateDialoguser() {
        long timdialogid = content.getLongValue("timdialogid");
        long tenterprise_userid = content.getLong("tenterprise_userid");
        String fimdialognotes = content.getString("fimdialognotes");
        int fisremove = content.getIntValue("fisremove");
        String status = dbConnect.runSqlUpdate("update timdialogusers set fisremove=" + fisremove + ",fimdialognotes='" + fimdialognotes + "' where siteid='" + siteid + "' and timdialogid='" + timdialogid + "' and tenterprise_userid='" + tenterprise_userid + "'");
        if ("true".equalsIgnoreCase(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().toString();
        }
    }

    /**
     * 컰
     *
     * @return
     */
    public String createSubject() throws D3bException, P2Exception {
        long timsubjectid = content.getLongValue("timsubjectid"); //ID ʱĬϴ0
        long timdialogid = content.getLongValue("timdialogid");

        if (timsubjectid == 0 && !dbConnect.runSqlQuery("select * from timsubject where siteid='" + siteid + "' and timdialogid='" + timdialogid + "' and fisclose=0 ").isEmpty()) {
            return getErrReturnObject().setErrMsg("ǰԻΪرյĻ⣬ɴµĻ").toString();
        }

        boolean ischange = timsubjectid > 0;

        PaoSetRemote timsubjectSet = getP2ServerSystemPaoSet("timsubject", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and timsubjectid='" + timsubjectid + "'");
        PaoRemote timsubject = null;
        if (timsubjectid <= 0 || timsubjectSet.isEmpty()) {
            timsubject = timsubjectSet.addAtEnd();
            timsubject.setValue("siteid", siteid, 11L);//ҵID
            timsubject.setValue("createby", username, 11L);//
            timsubject.setValue("createdate", sysdate, 11L);//ʱ
            timsubject.setValue("tagentsid", tagentsid, 11L);
            timsubject.setValue("tenterprise_userid", userid, 11L);
            timsubject.setValue("timdialogid", timdialogid, 11L);

            timsubjectid = timsubject.getUniqueIDValue();
        } else {
            timsubject = timsubjectSet.getPao(0);
        }
        PaoSetRemote timsubjectcontentSet = timsubject.getPaoSet("$timsubjectcontent", "timsubjectcontent");

        if (content.containsKey("fcontent") && !"".equals(content.getString("fcontent"))) {
            String fcontent = content.getString("fcontent", "timsubjectcontent.fcontent", "");//
            PaoRemote timsubjectcontent = timsubjectcontentSet.addAtEnd();
            timsubjectcontent.setValue("siteid", siteid, 11L);
            timsubjectcontent.setValue("createdate", sysdate, 11L);
            timsubjectcontent.setValue("timsubjectid", timsubjectid, 11L);
            timsubjectcontent.setValue("fcontent", fcontent, 11L);
        }
        timsubjectSet.save();
        content.put("timsubjectid", timsubjectid);
        if (ischange) {//ݱ֪ͨǰ˽ˢ
            for (long userid : getImDialogUserIds(timdialogid)) {
                if (parameter.websocketClients.containsKey(userid)) {
                    JSONObject methodobject = new JSONObject();
                    methodobject.put("type", "refreshimdialog");
                    methodobject.put("timdialogid", timdialogid);
                    for (WebClientSocket webClientSocket : parameter.websocketClients.get(userid).values()) {
                        webClientSocket.sendSystemMessage(methodobject);
                    }
                }
            }
        }
        return querySubject();
    }

    /**
     * ر
     *
     * @return
     * @throws D3bException
     * @throws P2Exception
     */
    public String closeSubject() throws D3bException, P2Exception {
        long timsubjectid = content.getLongValue("timsubjectid"); //ID ʱĬϴ0
        long timdialogid = content.getLongValue("timdialogid");
        String status = dbConnect.runSqlUpdate("update timsubject set fisclose=1,closedate=getDate() where siteid='" + siteid + "' and timsubjectid='" + timsubjectid + "'");
        if ("true".equals(status)) {
            for (long userid : getImDialogUserIds(timdialogid)) {
                if (parameter.websocketClients.containsKey(userid)) {
                    JSONObject methodobject = new JSONObject();
                    methodobject.put("type", "refreshimdialog");
                    methodobject.put("timdialogid", timdialogid);
                    for (WebClientSocket webClientSocket : parameter.websocketClients.get(userid).values()) {
                        webClientSocket.sendSystemMessage(methodobject);
                    }
                }
            }
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().toString();
        }
    }

    /**
     * ݲѯ
     *
     * @return
     */
    public String querySubject() {
        long timsubjectid = content.getLongValue("timsubjectid");
        SQLFactory timsubjectSQL = new SQLFactory(this, "ѯ");
        timsubjectSQL.addParameter("siteid", siteid);
        timsubjectSQL.addParameter("timsubjectid", timsubjectid);
        Rows imsubjectrows = dbConnect.runSqlQuery(timsubjectSQL.getSQL());

        for (Row imsubject : imsubjectrows) {
            SQLFactory timsubjectcontentSQL = new SQLFactory(this, "ݲѯ");
            timsubjectcontentSQL.addParameter("siteid", siteid);
            timsubjectcontentSQL.addParameter("timsubjectid", imsubject.getLong("timsubjectid"));
            Rows imsubjectcontentrows = dbConnect.runSqlQuery(timsubjectcontentSQL.getSQL());
            RowsMap map = getAttachmentUrl("timsubjectcontent", imsubjectcontentrows.toArrayList("timsubjectcontenid"));
            for (Row row : imsubjectcontentrows) {
                row.put("attinfos", map.get(row.getString("timsubjectcontenid")));
            }
            imsubject.put("imsubjectcontent", imsubjectcontentrows);
            if (!imsubject.getBoolean("fisclose")) {
                SQLFactory sqlFactory = new SQLFactory(this, "ݷ");
                sqlFactory.addParameter("siteid", siteid);
                sqlFactory.addParameter("timsubjectid", timsubjectid);
                sqlFactory.addParameter("tenterprise_userid", userid);
                sqlFactory.addParameter("tagentsid", tagentsid);
                dbConnect.runSqlUpdate(sqlFactory.getSQL());
            }
        }
        return getSucReturnObject().setData(imsubjectrows).toString();
    }

    /**
     * ݶԻIDѯδرյĻ
     *
     * @return
     */
    public String queryDialogUncloseSubject() {
        long timdialogid = content.getLongValue("timdialogid");
        Rows rows = dbConnect.runSqlQuery("select timsubjectid from timsubject where siteid='" + siteid + "' and timdialogid='" + timdialogid + "' and fisclose=0 order by timsubjectid desc");
        if (!rows.isEmpty()) {
            long timsubjectid = rows.get(0).getLong("timsubjectid");
            content.put("timsubjectid", timsubjectid);
            return querySubject();
        } else {
            return getSucReturnObject().toString();
        }
    }

    /**
     * ظ
     *
     * @return
     */
    public String subjectAnswer() {
        long timsubjectid = content.getLongValue("timsubjectid");
        dbConnect.runSqlUpdate("update timsubjectanalysis set fisanswer=1,fanswertime=getDate() where siteid='" + siteid + "' and timsubjectid='" + timsubjectid + "' and tenterprise_userid='" + userid + "' and fisanswer=0");
        return getSucReturnObject().toString();
    }

    /**
     * ͳϢѯ
     *
     * @return
     */
    public String querySubjectAnalysis() {
        long timsubjectid = content.getLongValue("timsubjectid");//ID
        long timdialogid = content.getLongValue("timdialogid");//ԻID

        SQLFactory sqlFactory = new SQLFactory(this, "ݷѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("timsubjectid", timsubjectid);
        sqlFactory.addParameter("timdialogid", timdialogid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : rows) {
            row.put("headportraiturl", getHeadPic(row.getLong("tenterprise_userid")));
        }
        RowsMap fisreadmap = rows.toRowsMap("fisread");
        RowsMap fisanswermap = rows.toRowsMap("fisanswer");

        JSONObject object = new JSONObject();
        object.put("readlist", fisreadmap.get("1").toJsonArray());
        object.put("unreadlist", fisreadmap.get("0").toJsonArray());

        object.put("answerlist", fisanswermap.get("1").toJsonArray());
        object.put("unanswerlist", fisanswermap.get("0").toJsonArray());

        return getSucReturnObject().setData(object).toString();
    }
}
