package com.cnd3b.restcontroller.system.message;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;

public class Message extends Controller {

    public Message(JSONObject content) {
        super(content);
    }

    public String queryMessage() {
        SQLFactory factory = null;
        if (content.containsKey("ftype") && !"".equals(content.getString("ftype"))) {
            factory = new SQLFactory(this, "Ϣѯ", pageSize, pageNumber, "fisread,createdate desc");
            factory.addParameter("ftype", content.getString("ftype"));
        } else {
            factory = new SQLFactory(this, "Ϣѯȫ", pageSize, pageNumber, "fisread,createdate desc");
        }
        factory.addParameter("siteid", siteid);
        factory.addParameter("tenterprise_userid", userid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        for (Row row : rows) {
            String ftitle = row.getString("ftitle");
            String ftype = row.getString("ftype");
            StringBuffer url = new StringBuffer("https://bwj.obs.cn-east-2.myhuaweicloud.com/resources/message/");
            if (ftype.equals("")) {
                url.append("xitong.png");
            } else {
                switch (ftitle) {
                    case "̻֪ͨ": {
                        url.append("shanghushenhe.png");
                        break;
                    }
                    case "º֪ͨ": {
                        url.append("hezuo.png");
                        break;
                    }
                    case "ȡ֪ͨ": {
                        url.append("quxiaohezuo.png");
                        break;
                    }
                    case "ŶӼ֪ͨ": {
                        url.append("tuanduijiaru.png");
                        break;
                    }
                    case "Ŷ˺Ȩޱ֪ͨ": {
                        url.append("biangeng.png");
                        break;
                    }
                    default:
                        url.append("quesheng.png");
                }
            }
            row.put("imageurl", url.toString());
        }
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    public String readMessage() {
        SQLFactory read = new SQLFactory(this, "ϢĶ");
        read.addParameter("siteid", siteid);
        read.addParameter("tenterprise_userid", userid);
        read.addParameter("tmessageid", content.getString("tmessageid"));

        SQLFactory factory = new SQLFactory(this, "Ϣ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tenterprise_userid", userid);
        factory.addParameter("tmessageid", content.getString("tmessageid"));
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        dbConnect.runSqlUpdate(read.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * δĶϢѯ
     *
     * @return
     */
    public String unReadMessageCount() {
        SQLFactory unread = new SQLFactory(this, "δĶϢѯ");
        unread.addParameter("siteid", siteid);
        unread.addParameter("tenterprise_userid", userid);
        Rows rows = dbConnect.runSqlQuery(unread.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }
}
