package com.cnd3b.service;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.BaseClass;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DBConnect;
import com.cnd3b.common.data.db.SQLiteJDBC;
import com.cnd3b.common.parameter.parameter;
import com.cnd3b.common.websocket.WebClientSocket;
import com.cnd3b.utility.polyv.Polyv;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;

/**
 * ͳݲѯƵ30һ
 */
public class GetPolyvAnalysisData extends BaseClass implements Runnable {
    @Override
    public void run() {
        if (new SQLiteJDBC().checkServicesUsed("GetPolyvAnalysisData", false)) {
            try {
                getLiveStatusAndCoverImageUrl();
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                getLiveUserCount();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * ͬƵֱ״̬,ȡֱͼ
     */
    public void getLiveStatusAndCoverImageUrl() {
        DBConnect dbConnect = new DBConnect();
        Rows channelRows = dbConnect.runSqlQuery("select channelid,livestatus,tagentsid,siteid from tlive");
        String[] channelids = channelRows.toArray("channelid");
        RowsMap map = channelRows.toRowsMap("channelid");
        Polyv polyv = new Polyv();
        HashMap<String, String> livestatusMap = new HashMap<>();
        //ͬʱѯ20Ƶ
        if (channelids.length > 20) {
            int size = channelids.length / 20;
            for (int i = 0; i < size; i++) {
                livestatusMap.putAll(polyv.getLiveStatuses(Arrays.copyOfRange(channelids, i * 20, (i + 1) * 20)));
            }
            livestatusMap.putAll(polyv.getLiveStatuses(Arrays.copyOfRange(channelids, size * 20, channelids.length)));
        } else {
            livestatusMap = polyv.getLiveStatuses(channelids);
        }

        ArrayList<String> sqllist = new ArrayList<>();
        for (String channelid : livestatusMap.keySet()) {
            String livestatus = livestatusMap.get(channelid);
            if (map.containsKey(channelid)) {
                if (livestatus.equalsIgnoreCase("live")) {
                    sqllist.add("update tlive set livestatus='" + livestatus + "',lastlivedate='" + getDate_Str() + "' ,channelcoverimageurl='" + polyv.getChannelImage(channelid, livestatus) + "' where channelid='" + channelid + "'");
                    if (!livestatus.equals(map.get(channelid).get(0).getString("livestatus"))) {
                        long tagentsid = map.get(channelid).get(0).getLong("tagentsid");
                        String siteid = map.get(channelid).get(0).getString("siteid");
                        createLiveMessage(siteid, tagentsid);
                    }
                } else if (livestatus.equalsIgnoreCase("waiting")) {
                    sqllist.add("update tlive set livestatus='" + livestatus + "',channelcoverimageurl='" + polyv.getChannelImage(channelid, livestatus) + "' where channelid='" + channelid + "'");
                } else {
                    sqllist.add("update tlive set livestatus='" + livestatus + "' where channelid='" + channelid + "'");
                }
            }
        }
        dbConnect.runSqlUpdate(sqllist);
    }

    /**
     * Ϣ
     */
    private void createLiveMessage(String siteid, long tagentsid) {
        try {
            //δֱ״̬Ϊֱ״̬򴴽ϵͳϢ
            DBConnect dbConnect = new DBConnect();
            Rows agentRows = dbConnect.runSqlQuery("select * from tagents where siteid='" + siteid + "' and tagentsid='" + tagentsid + "'");
            if (!agentRows.isEmpty()) {
                String fbrand = agentRows.get(0).getString("fbrand");
                Rows useridRows = dbConnect.runSqlQuery("select distinct t2.tenterprise_userid from tagents_cooperation t1 inner join tenterprise_users t2 on t1.siteid=t2.siteid and t1.tagentsid=t2.tagentsid where t1.tagentsid='" + tagentsid + "'");//ȡк̵˺б
                ArrayList<String> userids = useridRows.toArrayList("tenterprise_userid");
                SQLFactory factory = new SQLFactory(this, "ϵͳϢ");
                factory.addParameter("siteid", siteid);
                factory.addParameter("ftype", "̻");
                factory.addParameter("ftitle", "");
                factory.addParameter("fmessage", "̻" + fbrand + "ֱ");
                factory.addParameter_in("tenterprise_userid", userids);
                factory.addParameter("objectid", "null");
                factory.addParameter("objectname", "null");
                dbConnect.runSqlUpdate(factory.getSQL());
                for (String id : userids) {
                    long userid = Long.parseLong(id);
                    if (parameter.websocketClients.containsKey(userid)) {
                        JSONObject methodobject = new JSONObject();
                        methodobject.put("type", "remind");//
                        methodobject.put("text", "̻" + fbrand + "ֱ");
                        for (WebClientSocket webClientSocket : parameter.websocketClients.get(userid).values()) {
                            webClientSocket.sendSystemMessage(methodobject);
                        }
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     * ȡƵʵʱ
     */
    public void getLiveUserCount() {
        DBConnect dbConnect = new DBConnect();
        ArrayList<String> sqllist = new ArrayList<>();
        String[] channelids = dbConnect.runSqlQuery("select channelid from tlive where livestatus='live'").toArray("channelid");
        Polyv polyv = new Polyv();
        for (String channelid : channelids) {
            JSONObject object = polyv.getRealtimeViewers(channelid);
            String channelId = object.getString("channelId");
            String time = object.getString("time");
            String count = object.getString("count");

            SQLFactory sqlFactory = new SQLFactory(this, "ֱƵû");
            sqlFactory.addParameter("channelid", channelId);
            sqlFactory.addParameter("time", getDate_Str() + " " + time);
            sqlFactory.addParameter("count", count);
            sqllist.add(sqlFactory.getSQL());
        }
        dbConnect.runSqlUpdate(sqllist);

        SQLFactory sqlFactory = new SQLFactory(this, "ֱƵû");
        sqlFactory.addParameter_in("channelid", channelids);
        dbConnect.runSqlUpdate(sqlFactory);
    }

}
