package com.cnd3b.service;

import com.cnd3b.common.BaseClass;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DBConnect;
import com.cnd3b.common.data.db.SQLiteJDBC;
import com.cnd3b.utility.obs.BucketFile;
import p2.util.P2Exception;

import java.util.Calendar;

/**
 * 洢ʱ
 */
public class ObsAutoDelete extends BaseClass implements Runnable {

    @Override
    public void run() {
        if (new SQLiteJDBC().checkServicesUsed("ObsAutoDelete", true)) {
            try {
                clean();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        if (Calendar.getInstance().get(Calendar.HOUR_OF_DAY) == 3) {
            System.gc();
        }
    }

    public void clean() throws P2Exception {
        DBConnect dbConnect = new DBConnect();
        /**
         * һдڸı
         */
        Rows objectrows = dbConnect.runSqlQuery("select distinct ownertable,t2.uniquecolumnname from tattachment t1 inner join PS_SYSTABLES t2 on t1.ownertable=t2.tablename");
        for (Row objectrow : objectrows) {

            String objectname = objectrow.getString("ownertable");
            String uniquecolumnname = objectrow.getString("uniquecolumnname");

            Rows tattachmentrows = null;
            try {
                tattachmentrows = dbConnect.runSqlQuery("select t1.siteid,t1.tattachmentid,t1.serialnumber,t1.fdocument,t1.fparentid,t1.ftype from tattachment t1 left join " + objectname + " t2 on  t1.ownerid=t2." + uniquecolumnname + " inner join tobsmag t3 on t1.siteid=t3.siteid and t3.fisautoclean=1  where t1.ownertable='" + objectname + "' and t2." + uniquecolumnname + " is null");
            } catch (Exception e) {
                e.printStackTrace();
            }
            if (tattachmentrows != null) {
                for (Row tattachmentrow : tattachmentrows) {
                    String siteid = tattachmentrow.getString("siteid");
                    String ftype = tattachmentrow.getString("ftype");
                    String tattachmentid = tattachmentrow.getString("tattachmentid");
                    String serialnumber = tattachmentrow.getString("serialnumber");
                    String fdocument = tattachmentrow.getString("fdocument");
                    BucketFile bucketFile = new BucketFile(siteid);
                    if ("hls".equalsIgnoreCase(ftype)) {
                        bucketFile.deleteFolder(serialnumber);
                    } else {
                        bucketFile.deleteFile(serialnumber);
                    }
                    if (!bucketFile.doesObjectExist(serialnumber)) {
                        printInfoOut("ƴ洢ļ", siteid + "-" + objectname + "ID" + tattachmentid + "ƴ洢ļ" + serialnumber + "ļ" + fdocument);
                        SQLFactory sqlFactory = new SQLFactory(this, "Ϣɾ");
                        sqlFactory.addParameter("siteid", siteid);
                        sqlFactory.addParameter("tattachmentid", tattachmentid);
                        dbConnect.runSqlUpdate(sqlFactory.getSQL());
                    }
                    bucketFile.close();
                }
            }
        }
    }
}
