package com.cnd3b.service;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.BaseClass;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DBConnect;
import com.cnd3b.common.data.db.SQLiteJDBC;
import com.cnd3b.utility.obs.BucketFile;
import com.cnd3b.utility.obs.mpc.MpcFactory;
import com.cnd3b.utility.obs.mpc.MpcFile;

import java.util.ArrayList;

/**
 * Ϊƴ洢תѯ
 */
public class ObsMpcTaskQuery extends BaseClass implements Runnable {

    @Override
    public void run() {
        try {
            if (new SQLiteJDBC().checkServicesUsed("ObsMpcTaskQuery", true)) {
                mpcTask();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void mpcTask() {
        DBConnect dbConnect = new DBConnect();
        SQLFactory taskquerySQl = new SQLFactory(this, "תѯ");
        Rows rows = dbConnect.runSqlQuery(taskquerySQl.getSQL());

        ArrayList<String> list = new ArrayList<>();
        if (!rows.isEmpty()) {
            System.err.println("תѯ" + rows.size() + "");
        }
        MpcFactory mpcFactory = new MpcFactory();
        int rownum = 1;
        for (Row row : rows) {
            String siteid = row.getString("siteid");
            String tattachmentid = row.getString("tattachmentid");
            String mpctaskid = row.getString("mpctaskid");
            String ownertable = row.getString("ownertable");
            String ownerid = row.getString("ownerid");
            String postfix = row.getString("postfix");
            String fdocument = row.getString("fdocument");

            System.err.println("תѯʼִе" + (rownum++) + ",siteid:" + siteid + "tattachmentid:" + tattachmentid + "mpctaskid:" + mpctaskid);
            MpcFile file = mpcFactory.queryMpcTask(mpctaskid);
            if (file != null) {
                //תɹƵļ
                String objectname = file.getObject();
                System.err.println("תѯת" + objectname);
                String obsfilename = objectname + "/" + file.getOutput_file_name();

                BucketFile bucketFile = new BucketFile(siteid);
                if (!bucketFile.doesObjectExist(obsfilename)) {
                    System.err.println("תѯûҵʵļ" + obsfilename);
                    continue;
                }
                String fileurl = bucketFile.getFileUrl(obsfilename);
                System.err.println("תѯȡתļʵַ" + fileurl);

                //ͼϢ
                SQLFactory sqlFactory = new SQLFactory(this, "ӸϢ");
                sqlFactory.addParameter("fparentid", tattachmentid);
                sqlFactory.addParameter("tattachmentid", new Controller(new JSONObject()).createTableID("tattachment", "tattachmentid"));
                sqlFactory.addParameter("siteid", siteid);
                sqlFactory.addParameter("ownertable", ownertable);
                sqlFactory.addParameter("ownerid", ownerid);
                sqlFactory.addParameter("createby", "system");
                sqlFactory.addParameter("ftype", "hls");
                sqlFactory.addParameter("postfix", postfix);
                sqlFactory.addParameter("serialnumber", objectname);
                sqlFactory.addParameter("fdocument", fdocument);
                sqlFactory.addParameter("fobsurl", fileurl);
                sqlFactory.addParameter("contentlength", bucketFile.getObjectMetadata(obsfilename).getContentLength());

                list.add(sqlFactory.getSQL());
                list.add("update tattachment set mpctaskstatus=1 where tattachmentid='" + tattachmentid + "'");
                bucketFile.close();
            } else {
                System.err.println("תѯתδ");
            }
        }
        if (!list.isEmpty()) {
            System.err.println("¸ת·");
            String status = dbConnect.runSqlUpdate(list);
            if (!status.equals("true")) {
                System.err.println("תѯ:" + status);
            }
        }
    }

}
