package com.cnd3b.utility.obs;

import com.cnd3b.utility.WebRequest;
import com.obs.services.internal.utils.ServiceUtils;
import com.obs.services.model.HttpMethodEnum;
import com.obs.services.model.ObjectMetadata;
import com.obs.services.model.TemporarySignatureRequest;
import com.obs.services.model.TemporarySignatureResponse;
import com.obs.services.model.fs.DropFolderRequest;

import java.io.InputStream;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;

public class BucketFile extends Bucket {

    public BucketFile(String siteid) {
        super(siteid);
    }

    /**
     * ļϴļͼƬ,Զͼ
     */
    public void upload(String filename, InputStream inputStream, boolean iscreateMinImage) {
        obsClient.putObject(bucketname, filename, inputStream);

        /**
         * ͼƬļͬʱһͼļ
         */
        if (iscreateMinImage) {
            String filename_short = "s_" + filename;
            //ʱʵַЧʱ
            // ObsClientʵ
            TemporarySignatureRequest request = new TemporarySignatureRequest(HttpMethodEnum.GET, 3600);
            request.setBucketName(bucketname);
            request.setObjectKey(filename);

            // ͼƬͼƬνšת
            Map<String, Object> queryParams = new HashMap<String, Object>();
            queryParams.put("x-image-process", "image/resize,m_lfit,h_150");
            try {
                queryParams.put("x-image-save-object", ServiceUtils.toBase64(filename_short.getBytes(StandardCharsets.UTF_8)));
            } catch (Exception e) {
                e.printStackTrace();
            }
            request.setQueryParams(queryParams);
            // ʱȨURL
            TemporarySignatureResponse response = obsClient.createTemporarySignature(request);
            //ʱʣͼΪڵһηʸõַʱŻʵļ
            new WebRequest().doGet_simple(response.getSignedUrl());
        }
    }

    /**
     * ļɾ,ļļһɾ
     *
     * @param objectname
     */
    public void deleteFile(String objectname) {
        obsClient.deleteObject(bucketname, objectname);
//        if (obsClient.doesObjectExist(bucketname, "s_" + objectname)) {
//            obsClient.deleteObject(bucketname, "s_" + objectname);
//        }
//        if (obsClient.doesObjectExist(bucketname, "c_" + objectname)) {
//            obsClient.deleteObject(bucketname, "c_" + objectname);
//        }
    }

    public void deleteFolder(String foldername) {
        DropFolderRequest dropFolderRequest = new DropFolderRequest(bucketname, foldername);
        obsClient.dropFolder(dropFolderRequest);
    }

    public boolean doesObjectExist(String objectname) {
        return obsClient.doesObjectExist(bucketname, objectname);
    }

    /**
     * ȡļصַ
     */
    public String getFileUrl(String filename) {
        //ʱʵַЧʱ
        //long expireSeconds = 3600L;
        // ObsClientʵ
        TemporarySignatureRequest request = new TemporarySignatureRequest(HttpMethodEnum.GET, 3600);
        request.setBucketName(bucketname);
        request.setObjectKey(filename);
        // ʱȨURL
        TemporarySignatureResponse response = obsClient.createTemporarySignature(request);

        //ȡ÷urlҪͰùʲ
        String url = response.getSignedUrl();
        return url.substring(0, url.indexOf("?"));
    }

    /**
     * ȡļͼصַ,ͼΪԴļǰ"s_"
     */
    public String getMinImageUrl(String filename) {
        /**
         * ͼ
         */
        String filename_short = "s_" + filename;
        if (!obsClient.doesObjectExist(bucketname, filename_short)) {
            //ʱʵַЧʱ
            // ObsClientʵ
            TemporarySignatureRequest request = new TemporarySignatureRequest(HttpMethodEnum.GET, 3600);
            request.setBucketName(bucketname);
            request.setObjectKey(filename);

            // ͼƬͼƬνšת
            Map<String, Object> queryParams = new HashMap<String, Object>();
            queryParams.put("x-image-process", "image/resize,m_lfit,h_150");
            try {
                queryParams.put("x-image-save-object", ServiceUtils.toBase64(filename_short.getBytes(StandardCharsets.UTF_8)));
            } catch (Exception e) {
                e.printStackTrace();
            }
            request.setQueryParams(queryParams);
            // ʱȨURL
            TemporarySignatureResponse response = obsClient.createTemporarySignature(request);
            //ʱʣͼΪڵһηʸõַʱŻʵļ
            new WebRequest().doGet_simple(response.getSignedUrl());
        }
        return getFileUrl(filename_short);
    }

    /**
     * ȡļͼصַ,ͼΪԴļǰ"c_"
     */
    public String getCompressImageUrl(String filename) {
        /**
         * ͼ
         */
        String filename_short = "c_" + filename;
        if (!obsClient.doesObjectExist(bucketname, filename_short)) {
            //ʱʵַЧʱ
            // ObsClientʵ
            TemporarySignatureRequest request = new TemporarySignatureRequest(HttpMethodEnum.GET, 3600);
            request.setBucketName(bucketname);
            request.setObjectKey(filename);

            // ͼƬͼƬνšת
            Map<String, Object> queryParams = new HashMap<String, Object>();
            queryParams.put("x-image-process", "image/resize,p_60");//ѹ60%
            try {
                queryParams.put("x-image-save-object", ServiceUtils.toBase64(filename_short.getBytes(StandardCharsets.UTF_8)));
            } catch (Exception e) {
                e.printStackTrace();
            }
            request.setQueryParams(queryParams);
            // ʱȨURL
            TemporarySignatureResponse response = obsClient.createTemporarySignature(request);
            //ʱʣͼΪڵһηʸõַʱŻʵļ
            new WebRequest().doGet_simple(response.getSignedUrl());
        }
        return getFileUrl(filename_short);
    }

    public static void main(String agrs[]) {
        BucketFile bucketFile = new BucketFile("zjdm");
        System.err.println(bucketFile.getMinImageUrl("202105181621308129037B51e055c6.jpg"));

    }

    public ObjectMetadata getObjectMetadata(String objectname) {
        return obsClient.getObjectMetadata(bucketname, objectname);
    }

    /**
     * ر
     */
    public void close() {
        if (obsClient != null) {
            try {
                obsClient.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public String getUploadUrl(String filetype, String objectname, HttpMethodEnum type) throws Exception {
        long expireSeconds = 3600L;
        Map<String, String> headers = new HashMap<String, String>();
        String contentType = "application/octet-stream";
        if (type.equals(HttpMethodEnum.POST)) {
            contentType = "multipart/form-data";
        }
        if ("pdf".equalsIgnoreCase(filetype)) {
            contentType = "application/pdf";
        }
        headers.put("Content-Type", contentType);

        TemporarySignatureRequest request = new TemporarySignatureRequest(type, expireSeconds);
        request.setBucketName(bucketname);
        request.setObjectKey(objectname);
        request.setHeaders(headers);

        TemporarySignatureResponse response = obsClient.createTemporarySignature(request);
        return response.getSignedUrl();
    }


}
