package com.cnd3b.utility.polyv;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.BaseClass;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.db.DBConnect;
import junit.framework.Assert;
import net.polyv.common.v1.base.HttpUtil;
import net.polyv.common.v1.exception.PloyvSdkException;
import net.polyv.live.v1.config.LiveGlobalConfig;
import net.polyv.live.v1.constant.LiveConstant;
import net.polyv.live.v1.entity.account.LiveCreateCategoryRequest;
import net.polyv.live.v1.entity.account.LiveCreateCategoryResponse;
import net.polyv.live.v1.entity.account.LiveListCategoryRequest;
import net.polyv.live.v1.entity.account.LiveListCategoryResponse;
import net.polyv.live.v1.entity.channel.operate.*;
import net.polyv.live.v1.entity.web.auth.LiveChannelAuthExternalRequest;
import net.polyv.live.v1.entity.web.auth.LiveChannelAuthExternalResponse;
import net.polyv.live.v1.service.account.impl.LiveAccountServiceImpl;
import net.polyv.live.v1.service.channel.impl.LiveChannelOperateServiceImpl;
import net.polyv.live.v1.service.web.impl.LiveWebAuthServiceImpl;
import net.polyv.live.v1.util.LiveSignUtil;

import java.io.IOException;
import java.security.NoSuchAlgorithmException;
import java.util.*;

public class Polyv extends BaseClass {
    String appid = "g5jjxvl9da";
    String userid = "04de51d4c1";
    String appSecret = "6e1d88d7796949da842503e11ab818bd";

    public Polyv() {
        /**
         * ȫ
         */
        LiveGlobalConfig.init(appid, userid, appSecret);
    }

    /**
     * Ȩŵַ
     *
     * @return
     */
    public String getSignUrl(String channelId, String secretKey, long userid) {
        String ts = String.valueOf(System.currentTimeMillis());
        String url = "https://live.polyv.cn/watch/" + channelId;
        String signText = secretKey + userid + secretKey + ts;
        try {
            String sign = LiveSignUtil.md5Hex(signText);
            url += "?userid=" + userid + "&ts=" + ts + "&sign=" + sign;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return url;
    }

    /**
     * Ƶ
     *
     * @throws Exception
     * @throws NoSuchAlgorithmException
     */
    public LiveChannelResponse createChannel(String channelName, String channelPasswd, int categoryId) {
        LiveChannelRequest liveChannelRequest = new LiveChannelRequest();
        LiveChannelResponse liveChannelResponse = null;
        try {
            liveChannelRequest.setName(channelName);//Ƶ
            liveChannelRequest.setChannelPasswd(channelPasswd);//Ƶ룬Ȳܳ16λ
            liveChannelRequest.setAutoPlay(LiveConstant.AutoPlay.AOTU_PLAY.getFlag());//ǷԶűʶ0رԶţ1Ĭȡֵ 1
            //liveChannelRequest.setPlayerColor("#666666");//ɫĬϣ#666666
            //liveChannelRequest.setScene(LiveConstant.SceneType.ALONE.getDesc());//ֱalone ; ppt ; topclass ; seminar ֻ; Ĭϣalone
            liveChannelRequest.setCategoryId(categoryId);//ID ,½Ƶ࣬ύΪĬϷࣨIDͨȡֱࡱӿڵõ
            //liveChannelRequest.setMaxViewer(100);//ƵۿƵ
            //liveChannelRequest.setWatchLayout(LiveConstant.WatchLayout.PPT.getFlag());//ƵĹۿ֣pptĵΪvideoƵΪûʹ˺ŵͨ
            //liveChannelRequest.setLinkMicLimit(-1);//-1=<ȡֵΧ<=˺ż-1ʾʹ˺Ĭϵ16ˣע˺ż֪ͨƽ̨ԱòЧ
            //liveChannelRequest.setPureRtcEnabled(LiveConstant.Flag.NO.getFlag());//ǷΪʱֱY ʾĬΪN
            //liveChannelRequest.setReceive(LiveConstant.Flag.YES.getFlag());//ǷΪתƵYʾǣֵΪתƵ(עҪƵתܸòЧ)
            //liveChannelRequest.setReceiveChannelIds("");//תƵţƵðǶ,receiveֵΪYʱ˲Ч(עҪƵתܸòЧ)
            liveChannelResponse = new LiveChannelOperateServiceImpl().createChannel(liveChannelRequest);
            Assert.assertNotNull(liveChannelResponse);
            if (liveChannelResponse != null) {
                liveChannelResponse.getChannelId();
                liveChannelRequest.getChannelPasswd();
            }
            return liveChannelResponse;
        } catch (PloyvSdkException e) {
            //У鲻ϸ  500󣬴ϢPloyvSdkException.getMessage(),B
            //log.error(e.getMessage(), e);
            // 쳣B쳣ҵ߼¼log  ϱETL ߻ع
            throw e;
        } catch (Exception e) {
            // log.error("SDK쳣", e);
            e.printStackTrace();
        }
        return null;
    }

    /**
     * ޸Ƶ༰
     *
     * @throws Exception
     * @throws NoSuchAlgorithmException
     */
    public boolean updateChannelSetting(String channelId, String channelName, int categoryId) {
        LiveChannelSettingRequest liveChannelSettingRequest = new LiveChannelSettingRequest();
        Boolean liveChannelSettingResponse;
        try {
            LiveChannelSettingRequest.BasicSetting basicSetting = new LiveChannelSettingRequest.BasicSetting();
            basicSetting.setName(channelName);//Ƶ
            basicSetting.setCategoryId(categoryId);//޸Ƶ
            liveChannelSettingRequest.setChannelId(channelId)
                    .setBasicSetting(basicSetting);
            liveChannelSettingResponse = new LiveChannelOperateServiceImpl().updateChannelSetting(
                    liveChannelSettingRequest);
            Assert.assertTrue(liveChannelSettingResponse);
            return liveChannelSettingResponse;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }

    /**
     * رƵⲿȨ
     *
     * @throws Exception
     * @throws NoSuchAlgorithmException
     */
    public boolean closeChannelAuthExternal(String channelId) {
        LiveChannelSettingRequest liveChannelSettingRequest = new LiveChannelSettingRequest();
        Boolean liveChannelSettingResponse;
        try {
            LiveChannelSettingRequest.AuthSetting authSetting = new LiveChannelSettingRequest.AuthSetting()
                    .setRank(1)
                    .setEnabled("N");
            List<LiveChannelSettingRequest.AuthSetting> authSettings =
                    new ArrayList<LiveChannelSettingRequest.AuthSetting>();
            authSettings.add(authSetting);
            liveChannelSettingRequest.setChannelId(channelId)
                    .setAuthSettings(authSettings);
            liveChannelSettingResponse = new LiveChannelOperateServiceImpl().updateChannelSetting(
                    liveChannelSettingRequest);
            Assert.assertTrue(liveChannelSettingResponse);
            return liveChannelSettingResponse;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }

    /**
     * ƵⲿȨ
     *
     * @throws Exception
     * @throws NoSuchAlgorithmException
     */
    public String updateChannelAuthExternal(String channelId) {
        LiveChannelAuthExternalRequest liveChannelAuthExternalRequest = new LiveChannelAuthExternalRequest();
        LiveChannelAuthExternalResponse liveChannelAuthExternalResponse;
        try {
            liveChannelAuthExternalRequest.setChannelId(channelId);
            liveChannelAuthExternalRequest.setExternalUri("https://www.buwanjia.com/bwj/rest/webclientrest/polyvAuth");
            liveChannelAuthExternalResponse = new LiveWebAuthServiceImpl().updateChannelAuthExternal(
                    liveChannelAuthExternalRequest);
            Assert.assertNotNull(liveChannelAuthExternalResponse);
            if (liveChannelAuthExternalResponse != null && !liveChannelAuthExternalResponse.getChannelAuthExternals().isEmpty()) {
                return liveChannelAuthExternalResponse.getChannelAuthExternals().get(0).getSecretKey();
                //to do something ......
                //log.debug("ͨӿⲿȨɹ,{}", JSON.toJSONString(liveChannelAuthExternalResponse));
            }
        } catch (Exception e) {
            //У鲻ϸ  500󣬴ϢPloyvSdkException.getMessage()
            //log.error(e.getMessage(), e);
            // 쳣B쳣ҵ߼¼log  ϱETL ߻ع
            e.printStackTrace();
        }
        return null;
    }

    /**
     * Ƶɾ
     *
     * @throws Exception
     * @throws NoSuchAlgorithmException
     */
    public boolean deleteChannel(String channelId) {
        LiveDeleteChannelRequest liveDeleteChannelRequest = new LiveDeleteChannelRequest();
        Boolean liveDeleteChannelResponse;
        try {
            liveDeleteChannelRequest.setChannelId(channelId);
            liveDeleteChannelResponse = new LiveChannelOperateServiceImpl().deleteChannel(liveDeleteChannelRequest);
            Assert.assertNotNull(liveDeleteChannelResponse);
            return liveDeleteChannelResponse;
        } catch (PloyvSdkException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }

    /**
     * Ƶmap
     */
    public static HashMap<String, String> splashimageMap = new HashMap<>();
    public static HashMap<String, Long> splashimagetimeMap = new HashMap<>();

    /**
     * ȡƵͼƬƵ5һ
     *
     * @return
     */
    public String getChannelImage(String channelId, String livestatus) {
        if (!splashimageMap.containsKey(channelId) || !splashimagetimeMap.containsKey(channelId) || splashimagetimeMap.get(channelId) <= Calendar.getInstance().getTimeInMillis()) {
            splashimageMap.put(channelId, getChannelCapture(channelId, livestatus));
            splashimagetimeMap.put(channelId, Calendar.getInstance().getTimeInMillis() + 1000 * 60 * 5);
        }
        return splashimageMap.get(channelId);
    }

    /**
     * ѯƵʾͼƬƵֱʾֱͼֱʾͼ
     *
     * @return
     */
    public String getChannelCapture(String channelId, String livestatus) {
        if ("live".equals(livestatus)) {
            LiveChannelCaptureRequest liveChannelCaptureRequest = new LiveChannelCaptureRequest();
            String liveChannelCaptureResponse;
            try {
                liveChannelCaptureRequest.setChannelId(channelId);
                liveChannelCaptureResponse = new LiveChannelOperateServiceImpl().getChannelCapture(
                        liveChannelCaptureRequest);
                Assert.assertNotNull(liveChannelCaptureResponse);
                return "https:" + liveChannelCaptureResponse;
            } catch (PloyvSdkException | IOException | NoSuchAlgorithmException e) {
                e.printStackTrace();
            }
        }
        //return getChannelSplash(channelId, livestatus);
        return "https://bwj.obs.cn-east-2.myhuaweicloud.com/resources/defaultChannelSplash.jpg";
    }

    /**
     * ѯƵͼ(ͼ)
     *
     * @return
     */
    public String getChannelSplash(String channelId, String livestatus) {
        if ("waiting".equalsIgnoreCase(livestatus) || "end".equalsIgnoreCase(livestatus) || "playback".equalsIgnoreCase(livestatus)) {
            //ҵ
            String url = String.format("http://api.polyv.net/live/v2/channelSetting/%s/getSplash", channelId);
            try {
                Map<String, String> requestMap = new HashMap<>();
                requestMap.put("appId", appid);
                requestMap.put("timestamp", String.valueOf(System.currentTimeMillis()));
                requestMap.put("sign", LiveSignUtil.getSign(requestMap, appSecret));
                String response = HttpUtil.postFormBody(url, requestMap, null);
                JSONObject object = JSONObject.parseObject(response);
                if (object.containsKey("data") && object.getJSONObject("data").containsKey("splashImg") && object.getJSONObject("data").getString("splashImg") != null) {
                    return "https:" + object.getJSONObject("data").getString("splashImg");
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return "https://bwj.obs.cn-east-2.myhuaweicloud.com/resources/defaultChannelSplash.jpg";
    }

    /**
     * ֱ״̬map
     */
    public static HashMap<String, String> livestatusMap = new HashMap<>();
    public static HashMap<String, Long> livestatustimeMap = new HashMap<>();

    /**
     * ȡֱ״̬Ƶ60һ
     *
     * @return
     */
    public String getLiveStatus(String channelId) {
        if (!livestatusMap.containsKey(channelId) || !livestatustimeMap.containsKey(channelId) || livestatustimeMap.get(channelId) <= Calendar.getInstance().getTimeInMillis()) {
            getLiveStatuses(new String[]{channelId});
        }
        return livestatusMap.getOrDefault(channelId, "unStart");
    }

    /**
     * ȡֱ״̬
     *
     * @return
     */
    public HashMap<String, String> getLiveStatuses(String[] channelIdArray) {
        String channelIds = "";
        for (String channelId : channelIdArray) {
            if ("".equals(channelIds)) {
                channelIds = channelId;
            } else {
                if (channelId != null) {
                    channelIds = channelIds + "," + channelId;
                }

            }
        }
        //ҵ
        String url = "http://api.polyv.net/live/v4/channel/live-status/list";
        try {
            //http ߼
            Map<String, String> requestMap = new HashMap<>();
            requestMap.put("appId", appid);
            requestMap.put("timestamp", String.valueOf(System.currentTimeMillis()));
            requestMap.put("channelIds", channelIds);
            requestMap.put("sign", LiveSignUtil.getSign(requestMap, appSecret));
            String response = HttpUtil.get(url, requestMap, null);
            JSONObject object = JSONObject.parseObject(response);
            if (object.getBooleanValue("success")) {
                JSONArray dataArray = object.getJSONArray("data");
                for (Object o : dataArray) {
                    JSONObject statusObject = (JSONObject) o;
                    livestatusMap.put(statusObject.getString("channelId"), statusObject.getString("liveStatus"));
                    livestatustimeMap.put(statusObject.getString("channelId"), Calendar.getInstance().getTimeInMillis() + 1000 * 60);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return livestatusMap;
    }


    /**
     * ǰ̻б
     */
    public ArrayList<String> getLiveChannelList() {
        DBConnect dbConnect = new DBConnect();
        Rows rows = dbConnect.runSqlQuery("select channelid from tlive");
        /**
         * ȡֱĿ״̬
         */
        getLiveStatuses(rows.toArray("channelid"));
        /**
         * ڿ״̬Ƶ뻺
         */
        ArrayList<String> livechannellist = new ArrayList<>();
        for (String channelid : livestatusMap.keySet()) {
            if ("live".equalsIgnoreCase(livestatusMap.get(channelid))) {
                livechannellist.add(channelid);
            }
        }
        return livechannellist;
    }


    /**
     * ȡƵʵʱ
     *
     * @throws IOException
     * @throws NoSuchAlgorithmException
     */
    public JSONObject getRealtimeViewers(String channelId) {
        //ҵ
        String url = "https://api.polyv.net/live/v2/statistics/get-realtime-viewers";
        try {
            //http ߼
            Map<String, String> requestMap = new HashMap<>();
            requestMap.put("appId", appid);
            requestMap.put("timestamp", String.valueOf(System.currentTimeMillis()));
            requestMap.put("userId", userid);
            requestMap.put("channelIds", channelId);
            requestMap.put("sign", LiveSignUtil.getSign(requestMap, appSecret));
            String response = HttpUtil.get(url, requestMap, null);
            JSONObject object = JSONObject.parseObject(response);
            if ("success".equalsIgnoreCase(object.getString("status"))) {
                JSONArray dataArray = object.getJSONArray("data");
                for (Object o : dataArray) {
                    return (JSONObject) o;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }


    /**
     * ȡƵϢб
     *
     * @throws IOException
     * @throws NoSuchAlgorithmException
     */
    public JSONObject getPageViewlog(String channelId, String currentDay, String pageSize, String page) {
        //ҵ
        String url = String.format("http://api.polyv.net/live/v2/statistics/%s/viewlog", channelId);
        try {
//      String currentDay = "2021-1-20";
//      String page = "1";
//      String startTime = "1611072000000";
//      String endTime = "1611158400000";
//      String param1 = "1b448be323";
//      String param2 = "Ա";
//      String param3 = "live";
            //http ߼
            Map<String, String> requestMap = new HashMap<>();
            requestMap.put("appId", appid);
            requestMap.put("timestamp", String.valueOf(System.currentTimeMillis()));
            requestMap.put("currentDay", currentDay);
            requestMap.put("page", page);
            requestMap.put("pageSize", pageSize);
//      requestMap.put("startTime", startTime);
//      requestMap.put("endTime", endTime);
//      requestMap.put("param1", param1);
//      requestMap.put("param2", param2);
//      requestMap.put("param3", param3);
            requestMap.put("sign", LiveSignUtil.getSign(requestMap, appSecret));
            String response = HttpUtil.get(url, requestMap, null);
            JSONObject object = JSONObject.parseObject(response);
            if ("success".equalsIgnoreCase(object.getString("status"))) {
                return object.getJSONObject("data");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * ȡƵ¼б
     *
     * @throws IOException
     * @throws NoSuchAlgorithmException
     */
    public JSONObject getPageMessageList(String channelId, String startDay, String endDay, String pageSize, String page) {
        //ҵ
        String url = "http://api.polyv.net/live/v3/channel/chat/get-history-page";
        try {
            String userType = "";//ûͣѡͣӢĶŸ  sliceƿѧԱ teacherʦ guestα managerԱ assistant viewer monitor attendeeֻ studentֱͨ
            String status = "";//¼״̬Ĭpass pass censorкɾ
            String source = "";//ͣĬϹ extendԱ˽
            String roomId = "";//зţҪ뷿ţĬϲ

            //http ߼
            Map<String, String> requestMap = new HashMap<>();
            requestMap.put("appId", appid);
            requestMap.put("timestamp", String.valueOf(System.currentTimeMillis()));
            requestMap.put("startDay", startDay);
            requestMap.put("endDay", endDay);
            requestMap.put("channelId", channelId);
            requestMap.put("page", page);
            requestMap.put("pageSize", pageSize);
            requestMap.put("userType", userType);
            requestMap.put("status", status);
            requestMap.put("source", source);
            requestMap.put("roomId", roomId);
            requestMap.put("sign", LiveSignUtil.getSign(requestMap, appSecret));
            String response = HttpUtil.get(url, requestMap, null);
            JSONObject object = JSONObject.parseObject(response);
            if ("success".equalsIgnoreCase(object.getString("status"))) {
                return object.getJSONObject("data");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }


    /**
     * ȡѯƵͳ
     *
     * @throws IOException
     * @throws NoSuchAlgorithmException
     */
    public JSONArray getChannelSummary(String[] channelIdArray, String currentDay) {
        String channelIds = "";
        for (String channelId : channelIdArray) {
            if ("".equals(channelIds)) {
                channelIds = channelId;
            } else {
                channelIds = channelIds + "," + channelId;
            }
        }
        try {
            //ҵ
            String url = String.format("http://api.polyv.net/live/v2/statistics/%s/channel_summary", userid);
            //http ߼
            Map<String, String> requestMap = new HashMap<>();
            requestMap.put("appId", appid);
            requestMap.put("timestamp", String.valueOf(System.currentTimeMillis()));
            requestMap.put("startDate", currentDay);
            requestMap.put("endDate", currentDay);
            requestMap.put("channelIds", channelIds);
            requestMap.put("sign", LiveSignUtil.getSign(requestMap, appSecret));
            String response = HttpUtil.postFormBody(url, requestMap, null);
            JSONObject object = JSONObject.parseObject(response);
            if ("success".equalsIgnoreCase(object.getString("status"))) {
                return object.getJSONArray("data");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * ѯƵೡθͳ
     *
     * @throws IOException
     * @throws NoSuchAlgorithmException
     */
    public JSONArray getSessionStats(String channelId) {
        try {
            //ҵ
            String url = "https://api.polyv.net/live/v3/channel/statistics/get-session-stats";
            //http ߼
            Map<String, String> requestMap = new HashMap<>();
            requestMap.put("appId", appid);
            requestMap.put("timestamp", String.valueOf(System.currentTimeMillis()));
            requestMap.put("userId", userid);
            requestMap.put("channelId", channelId);
            //requestMap.put("sessionIds","");
            requestMap.put("startTime", String.valueOf(getDate().getTime()));
            requestMap.put("endTime", String.valueOf(System.currentTimeMillis()));
            requestMap.put("sign", LiveSignUtil.getSign(requestMap, appSecret));
            String response = HttpUtil.get(url, requestMap, null);
            JSONObject object = JSONObject.parseObject(response);
            if ("success".equalsIgnoreCase(object.getString("status"))) {
                return object.getJSONObject("data").getJSONArray("list");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * ֱ
     *
     * @throws Exception
     */
    public LiveCreateCategoryResponse createCategory(String categoryname) {
        LiveCreateCategoryRequest liveCreateCategoryRequest = new LiveCreateCategoryRequest();
        LiveCreateCategoryResponse liveCreateCategoryResponse;
        try {
            liveCreateCategoryRequest.setCategoryName(categoryname);
            liveCreateCategoryResponse = new LiveAccountServiceImpl().createCategory(liveCreateCategoryRequest);
            Assert.assertNotNull(liveCreateCategoryResponse);
            return liveCreateCategoryResponse;
        } catch (PloyvSdkException | IOException | NoSuchAlgorithmException e) {
            e.printStackTrace();
        }
        return null;
    }


    /**
     * ֱ״̬map
     */
    public static HashMap<Integer, String> categoryMap = new HashMap<>();
    public static long categorytime = 0L;

    /**
     * ȡֱбƵ30һ
     *
     * @throws Exception
     */
    public HashMap<Integer, String> listCategory() {
        if (categoryMap.isEmpty() || categorytime <= Calendar.getInstance().getTimeInMillis()) {
            LiveListCategoryRequest liveListCategoryRequest = new LiveListCategoryRequest();
            LiveListCategoryResponse liveListCategoryResponse;
            try {
                liveListCategoryResponse = new LiveAccountServiceImpl().listCategory(liveListCategoryRequest);
                Assert.assertNotNull(liveListCategoryResponse);
                List<LiveListCategoryResponse.LiveCategory> categoryList = liveListCategoryResponse.getLiveCategories();
                for (LiveListCategoryResponse.LiveCategory liveCategory : categoryList) {
                    categoryMap.put(liveCategory.getCategoryId(), liveCategory.getCategoryName());
                }
                categorytime = Calendar.getInstance().getTimeInMillis() + 1000 * 60 * 30;
            } catch (PloyvSdkException | IOException | NoSuchAlgorithmException e) {
                e.printStackTrace();
            }
        }
        return categoryMap;
    }

}
