package com.cnd3b.utility.qywechat.base;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;
import java.nio.charset.StandardCharsets;
import java.util.List;
import java.util.Map;
public class SendMsg {

    private String address = "https://qyapi.weixin.qq.com/cgi-bin/message/send?access_token=";
    private URLConnection connection;
    private OutputStreamWriter out;
    private URL url;

    public SendMsg() throws IOException {
        try {
            address = address + GetAccessToken.get();
            url = new URL(address);
            connection = url.openConnection();
            connection.setDoOutput(true);
            connection.setConnectTimeout(500);
            out = new OutputStreamWriter(connection.getOutputStream(), StandardCharsets.UTF_8);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * ûϢ
     *
     * @param tousers  ԱIDбϢߣá|ָ֧1000ָΪ@all עҵӦõȫԱ
     * @param topartys IDбá|ָ֧100touserΪ@allʱԱ
     * @param appid    ҵӦõid͡Ӧõҳ鿴
     * @param save     ʾǷǱϢ0ʾ1ʾǣĬ0
     * @param content  Ϣ
     * @return طϢĽǷɹ
     * @throws IOException
     */
    public String TextMsg(String[] tousers, String[] topartys, String appid, String save, String content)
            throws IOException {
        JSONObject object = new JSONObject();
        object.put("touser", join(tousers));
        object.put("toparty", join(topartys));
        object.put("totag", null);
        object.put("msgtype", "text");
        object.put("agentid", appid);
        JSONObject textobject = new JSONObject();
        textobject.put("content", content);
        object.put("text", textobject);
        object.put("safe", save);
        return Send(object);
    }

    /**
     * @param tousers  ԱIDбϢߣá|ָ֧1000ָΪ@all עҵӦõȫԱ
     * @param topartys IDбá|ָ֧100touserΪ@allʱԱ
     * @param appid    ҵӦõid͡Ӧõҳ鿴
     * @param save     ʾǷǱϢ0ʾ1ʾǣĬ0
     * @param MEDIA_ID ͼƬýļidԵϴʱزĻزĽӿڻȡ,زmedia_idɷϢӦô
     * @return طϢĽǷɹ
     * @throws IOException
     */
    public String ImageMsg(String[] tousers, String[] topartys, String appid, String save, String MEDIA_ID)
            throws IOException {
        JSONObject object = new JSONObject();
        object.put("touser", join(tousers));
        object.put("toparty", join(topartys));
        object.put("totag", null);
        object.put("msgtype", "image");
        object.put("agentid", appid);
        JSONObject textobject = new JSONObject();
        textobject.put("media_id", MEDIA_ID);
        object.put("image", textobject);
        object.put("safe", save);
        return Send(object);
    }

    /**
     * @param tousers  ԱIDбϢߣá|ָ֧1000ָΪ@all עҵӦõȫԱ
     * @param topartys IDбá|ָ֧100touserΪ@allʱԱ
     * @param appid    ҵӦõid͡Ӧõҳ鿴
     * @param save     ʾǷǱϢ0ʾ1ʾǣĬ0
     * @param MEDIA_ID ͼƬýļidԵϴʱزĻزĽӿڻȡ,زmedia_idɷϢӦô
     * @return طϢĽǷɹ
     * @throws IOException
     */
    public String VoiceMsg(String[] tousers, String[] topartys, String appid, String save, String MEDIA_ID)
            throws IOException {
        JSONObject object = new JSONObject();
        object.put("touser", join(tousers));
        object.put("toparty", join(topartys));
        object.put("totag", null);
        object.put("msgtype", "voice");
        object.put("agentid", appid);
        JSONObject textobject = new JSONObject();
        textobject.put("media_id", MEDIA_ID);
        object.put("voice", textobject);
        object.put("safe", save);
        return Send(object);
    }

    /**
     * @param tousers     ԱIDбϢߣá|ָ֧1000ָΪ@all עҵӦõȫԱ
     * @param topartys    IDбá|ָ֧100touserΪ@allʱԱ
     * @param appid       ҵӦõid͡Ӧõҳ鿴
     * @param save        ʾǷǱϢ0ʾ1ʾǣĬ0
     * @param MEDIA_ID    ͼƬýļidԵϴʱزĻزĽӿڻȡ,زmedia_idɷϢӦô
     * @param Title       ƵϢı
     * @param Description ƵϢ
     * @return طϢĽǷɹ
     * @throws IOException
     */
    public String VideoMsg(String[] tousers, String[] topartys, String appid, String save, String MEDIA_ID,
                           String Title, String Description) throws IOException {
        JSONObject object = new JSONObject();
        object.put("touser", join(tousers));
        object.put("toparty", join(topartys));
        object.put("totag", null);
        object.put("msgtype", "video");
        object.put("agentid", appid);
        JSONObject textobject = new JSONObject();
        textobject.put("media_id", MEDIA_ID);
        textobject.put("title", Title);
        textobject.put("description", Description);
        object.put("video", textobject);
        object.put("safe", save);
        return Send(object);
    }

    /**
     * @param tousers  ԱIDбϢߣá|ָ֧1000ָΪ@all עҵӦõȫԱ
     * @param topartys IDбá|ָ֧100touserΪ@allʱԱ
     * @param appid    ҵӦõid͡Ӧõҳ鿴
     * @param save     ʾǷǱϢ0ʾ1ʾǣĬ0
     * @param MEDIA_ID ͼƬýļidԵϴʱزĻزĽӿڻȡ,زmedia_idɷϢӦô
     * @return طϢĽǷɹ
     * @throws IOException
     */
    public String fileMsg(String[] tousers, String[] topartys, String appid, String save, String MEDIA_ID)
            throws IOException {
        JSONObject object = new JSONObject();
        object.put("touser", join(tousers));
        object.put("toparty", join(topartys));
        object.put("totag", null);
        object.put("msgtype", "file");
        object.put("agentid", appid);
        JSONObject textobject = new JSONObject();
        textobject.put("media_id", MEDIA_ID);
        object.put("file", textobject);
        object.put("safe", save);
        return Send(object);
    }

    /**
     * @param tousers  ԱIDбϢߣá|ָ֧1000ָΪ@all עҵӦõȫԱ
     * @param topartys IDбá|ָ֧100touserΪ@allʱԱ
     * @param appid    ҵӦõid͡Ӧõҳ鿴
     * @param news     б ΪList<Map<String, String>>mapеKEYΪ
     *                 titledescriptionurlpicurl title description
     *                 urlתӡ picurlͼϢͼƬӣ֧JPGPNGʽϺõЧΪͼ640*320Сͼ80
     *                 *80粻ڿͻ˲ʾͼƬ
     * @return
     * @throws IOException
     */
    public String NewsMsg(String[] tousers, String[] topartys, String appid, List<Map<String, String>> news)
            throws IOException {
        JSONObject object = new JSONObject();
        object.put("touser", join(tousers));
        object.put("toparty", join(topartys));
        object.put("totag", null);
        object.put("msgtype", "news");
        object.put("agentid", appid);
        JSONObject newsobject = new JSONObject();
        JSONArray jsonArray = new JSONArray();
        for (Map<String, String> map : news) {
            JSONObject newobject = new JSONObject();
            newobject.put("title", map.get("title"));
            newobject.put("description", map.get("description"));
            newobject.put("url", map.get("url"));
            newobject.put("picurl", map.get("picurl"));
            jsonArray.add(newobject);
        }
        newsobject.put("articles", jsonArray);
        object.put("news", newsobject);
        return Send(object);
    }

    public String NewsMsg(String[] tousers, String[] topartys, String appid, JSONObject news) throws IOException {
        JSONObject object = new JSONObject();
        object.put("touser", join(tousers));
        object.put("toparty", join(topartys));
        object.put("totag", null);
        object.put("msgtype", "news");
        object.put("agentid", appid);
        object.put("news", news);
        return Send(object);
    }

    private String Send(JSONObject object) throws IOException {
        out.write(object.toString()); // ֯ύϢ
        out.flush();
        out.close();
        // ȡ
        BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream()));
        String line = null;
        StringBuffer content = new StringBuffer();
        while ((line = in.readLine()) != null) {
            // lineΪֵͿжǷɹ
            content.append(line);
        }
        in.close();
        return content.toString();
    }

    /**
     * ֵתַ
     *
     * @param a
     * @return
     */
    public String join(String[] a) {
        StringBuilder b = null;
        if (a == null) {
            return b.toString();
        }
        for (String c : a) {
            if (b == null || b.toString().equals("")) {
                b = new StringBuilder(c);
            } else {
                b.append("|").append(c);
            }
        }
        return b.toString();
    }
}
