package com.cnd3b.utility.qywechat.base.system;

@SuppressWarnings("serial")
public class AesException extends Exception {

	public final static int OK = 0;
	public final static int ValidateSignatureError = -40001;
	public final static int ParseXmlError = -40002;
	public final static int ComputeSignatureError = -40003;
	public final static int IllegalAesKey = -40004;
	public final static int ValidateAppidError = -40005;
	public final static int EncryptAESError = -40006;
	public final static int DecryptAESError = -40007;
	public final static int IllegalBuffer = -40008;
	//public final static int EncodeBase64Error = -40009;
	//public final static int DecodeBase64Error = -40010;
	//public final static int GenReturnXmlError = -40011;

	private int code;

	private static String getMessage(int code) {
		switch (code) {
		case ValidateSignatureError:
			return "ǩ֤";
		case ParseXmlError:
			return "xmlʧ";
		case ComputeSignatureError:
			return "shaǩʧ";
		case IllegalAesKey:
			return "SymmetricKeyǷ";
		case ValidateAppidError:
			return "appidУʧ";
		case EncryptAESError:
			return "aesʧ";
		case DecryptAESError:
			return "aesʧ";
		case IllegalBuffer:
			return "ܺõbufferǷ";
//		case EncodeBase64Error:
//			return "base64ܴ";
//		case DecodeBase64Error:
//			return "base64ܴ";
//		case GenReturnXmlError:
//			return "xmlʧ";
		default:
			return null;
		}
}

	public int getCode() {
		return code;
	}

	AesException(int code) {
		super(getMessage(code));
		this.code = code;
	}

}
