package com.cnd3b.utility.wechatpay.jsapipay.POJO;

import com.cnd3b.utility.WebRequest;
import com.cnd3b.utility.wechatpay.jsapipay.parameter;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.dom4j.dom.DOMElement;

import java.util.Iterator;

public class JSCreateOrderRequest extends Base {
    private String appid;//ӦID
    private String body;//Ʒ
    private String mch_id;//̻
    private String notify_url;//ַ֪ͨ
    private String out_trade_no;//̻
    private String spbill_create_ip;//նIP
    private Integer total_fee;//ܽ
    private String trade_type;//
    private String openid;


    public void setAppid(String appid) {
        this.appid = appid;
    }


    public void setBody(String body) {
        this.body = body;
    }


    public void setMch_id(String mch_id) {
        this.mch_id = mch_id;
    }


    public void setNotify_url(String notify_url) {
        this.notify_url = notify_url;
    }


    public void setOut_trade_no(String out_trade_no) {
        this.out_trade_no = out_trade_no;
    }


    public void setSpbill_create_ip(String spbill_create_ip) {
        this.spbill_create_ip = spbill_create_ip;
    }


    public void setTotal_fee(int total_fee) {
        this.total_fee = total_fee;
    }


    public void setTrade_type(String trade_type) {
        this.trade_type = trade_type;
    }

    public void setOpenid(String openid) {
        this.openid = openid;
    }

    public JSCreateOrderResponse getOrderResponse() {
        String requestxml = asXml();
        String res = new WebRequest().doPost(requestxml, parameter.createorder_url);
        return getCreateOrderResponse(res);
    }

    private String asXml() {
        DOMElement request = new DOMElement("xml");
        request.addElement("appid").addText(appid);//ӦID
        request.addElement("body").addText(body);//Ʒ
        request.addElement("mch_id").addText(mch_id);//̻ID
        request.addElement("nonce_str").addText(createNonce_str(out_trade_no + spbill_create_ip));//ַ
        request.addElement("notify_url").addText(notify_url);//ַ֧֪ͨ
        request.addElement("openid").addText(openid);//
        request.addElement("out_trade_no").addText(out_trade_no);//̻
        request.addElement("spbill_create_ip").addText(spbill_create_ip);//նIP
        request.addElement("total_fee").addText(String.valueOf(total_fee));//ܽ
        request.addElement("trade_type").addText(trade_type);//

        createSign(request);
        return request.asXML();
    }

    private JSCreateOrderResponse getCreateOrderResponse(String response) {
        JSCreateOrderResponse orderResponse = new JSCreateOrderResponse();
        try {
            Document respones = DocumentHelper.parseText(response);
            Iterator<Element> it = respones.getRootElement().elementIterator();
            while (it.hasNext()) {
                Element element = it.next();
                String key = element.getName();
                String text = element.getText();
                switch (key) {
                    case "return_code": {
                        orderResponse.setReturn_code(text);
                        break;
                    }
                    case "return_msg": {
                        orderResponse.setReturn_msg(text);
                        break;
                    }
                    case "appid": {
                        orderResponse.setAppid(text);
                        break;
                    }
                    case "mch_id": {
                        orderResponse.setMch_id(text);
                        break;
                    }
                    case "device_info": {
                        orderResponse.setDevice_info(text);
                        break;
                    }
                    case "nonce_str": {
                        orderResponse.setNonce_str(text);
                        break;
                    }
                    case "sign": {
                        orderResponse.setSign(text);
                        break;
                    }
                    case "result_code": {
                        orderResponse.setResult_code(text);
                        break;
                    }
                    case "err_code": {
                        orderResponse.setErr_code(text);
                        break;
                    }
                    case "err_code_des": {
                        orderResponse.setErr_code_des(text);
                        break;
                    }
                    case "trade_type": {
                        orderResponse.setTrade_type(text);
                        break;
                    }
                    case "prepay_id": {
                        orderResponse.setPrepay_id(text);
                        break;
                    }
                    default:
                        break;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return orderResponse;
    }


}
